Index: src/backend/postmaster/pgstat.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/postmaster/pgstat.c,v
retrieving revision 1.187
diff -c -r1.187 pgstat.c
*** src/backend/postmaster/pgstat.c	1 Jan 2009 17:23:46 -0000	1.187
--- src/backend/postmaster/pgstat.c	15 Apr 2009 06:08:04 -0000
***************
*** 111,116 ****
--- 111,117 ----
  bool		pgstat_track_counts = false;
  int			pgstat_track_functions = TRACK_FUNC_OFF;
  int			pgstat_track_activity_query_size = 1024;
+ char	   *pgstat_temp_directory;
  
  /* ----------
   * Built from GUC parameter
***************
*** 589,594 ****
--- 590,600 ----
  		return 0;
  
  	/*
+ 	 * Create temporary statistics directory if not present; ignore errors
+ 	 */
+ 	mkdir(pgstat_temp_directory, 0700);
+ 
+ 	/*
  	 * Do nothing if too soon since last collector start.  This is a safety
  	 * valve to protect against continuous respawn attempts if the collector
  	 * is dying immediately at launch.	Note that since we will be re-called
Index: src/backend/utils/misc/guc.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/misc/guc.c,v
retrieving revision 1.502
diff -c -r1.502 guc.c
*** src/backend/utils/misc/guc.c	7 Apr 2009 23:27:34 -0000	1.502
--- src/backend/utils/misc/guc.c	15 Apr 2009 06:08:18 -0000
***************
*** 375,382 ****
  char	   *IdentFileName;
  char	   *external_pid_file;
  
- char	   *pgstat_temp_directory;
- 
  int			tcp_keepalives_idle;
  int			tcp_keepalives_interval;
  int			tcp_keepalives_count;
--- 375,380 ----
Index: src/include/pgstat.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/pgstat.h,v
retrieving revision 1.82
diff -c -r1.82 pgstat.h
*** src/include/pgstat.h	4 Jan 2009 22:19:59 -0000	1.82
--- src/include/pgstat.h	15 Apr 2009 06:08:22 -0000
***************
*** 593,598 ****
--- 593,599 ----
  extern bool pgstat_track_counts;
  extern int	pgstat_track_functions;
  extern PGDLLIMPORT int	pgstat_track_activity_query_size;
+ extern PGDLLIMPORT char *pgstat_temp_directory;
  extern char *pgstat_stat_tmpname;
  extern char *pgstat_stat_filename;
  
